<template>
  <div class="goods">
    <div class="breadcrumb-wrap">
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>商品管理</el-breadcrumb-item>
        <el-breadcrumb-item>商品列表</el-breadcrumb-item>
      </el-breadcrumb>
    </div>

    <el-alert title="添加商品信息" type="info" center :closable="false" show-icon></el-alert>

    <el-steps
      style="margin-top:15px;margin-bottom:30px;"
      align-center
      :space="400"
      :active="+currentIndex"
      finish-status="success"
    >
      <el-step v-for="(item,index) in messageArr" :key="index" :title="item"></el-step>
    </el-steps>

    <el-tabs
      tab-click="tabClick"
      v-model="currentIndex"
      tab-position="left"
      @tab-click="tabClick"
      style="height: 300px;margin-top:10px;overflow-y:scroll;"
    >
      <el-tab-pane name="1" label="基本信息">
        <el-form label-position="top" label-width="80px" :model="normal">
          <el-form-item label="商品名称">
            <el-input v-model="normal.goods_name"></el-input>
          </el-form-item>
          <el-form-item label="商品价格">
            <el-input v-model="normal.goods_price"></el-input>
          </el-form-item>
          <el-form-item label="商品重量">
            <el-input v-model="normal.goods_weight"></el-input>
          </el-form-item>
          <el-form-item label="商品数量">
            <el-input v-model="normal.goods_number"></el-input>
          </el-form-item>
          <el-form-item label="商品分类">
            <el-cascader
              v-model="normal.goods_cat"
              :options="options"
              clearable
              :props="{ 
                  expandTrigger: 'hover' ,
                  value:'cat_id',
                  label:'cat_name'     
                  }"
            ></el-cascader>
          </el-form-item>
        </el-form>
      </el-tab-pane>
      <el-tab-pane name="2" label="商品参数">
        <ul>
          <li v-for="(item,index) in this. normal.attrs" :key="index">
            <h3 style="padding:20px 0px;">{{item.attr_name}}</h3>
            <div>
              <el-checkbox
                @change="removerItem(index,_index)"
                v-for="(_item,_index) in item.attr_vals"
                :key="_index"
                checked
                indeterminate
                :label="_item"
                border
              ></el-checkbox>
            </div>
          </li>
        </ul>
      </el-tab-pane>
      <el-tab-pane name="3" label="商品属性">
        <el-form label-position="top" label-width="80px" :model="normal.goods_attrs">
          <el-form-item
            :label="item.attr_name"
            v-for="item in normal.goods_attrs"
            :key="item.attr_id"
          >
            <el-input v-model="item.attr_vals"></el-input>
          </el-form-item>
        </el-form>
      </el-tab-pane>
      <el-tab-pane name="4" label="商品图片">
        <el-upload
          class="upload-demo"
          :action="url"
          :headers="headers"
          list-type="picture"
          :on-success="getUrl"
          :on-remove="removeUrl"
        >
          <el-button size="small" type="primary">点击上传</el-button>
          <div slot="tip" class="el-upload__tip">只能上传jpg/png文件，且不超过500kb</div>
        </el-upload>
      </el-tab-pane>
      <el-tab-pane name="5" label="商品内容">
          <el-button @click="publicGoods">发布商品</el-button>
          <quill-editor  v-model=" normal.goods_introduce" ref="editor"></quill-editor>
      </el-tab-pane>
    </el-tabs>
  </div>
</template>

<script>
import 'quill/dist/quill.core.css'
import 'quill/dist/quill.snow.css'
import 'quill/dist/quill.bubble.css'

import {quillEditor} from 'vue-quill-editor'
import {
  getGoodsLists,
  commodityClassifyLists,
  getDynamicParameter,
  getOnlyParameter,
  uploadImg,
  publicGoods
} from "@/http/api";
import moment from "moment";
export default {
    components:{
        quillEditor
    },
  data() {
    return {
      messageArr: ["基本信息", "商品参数", "商品属性", "商品图片", "商品内容"],
      currentIndex: "1",
      normal: {
        goods_name: "",
        goods_price: "",
        goods_weight: "",
        goods_number: "",
        goods_cat: '',
        goods_attrs: null,
        goods_introduce:"",
        attrs: [],
        pics: []
      },
      options: [],
      checkedVal: true,
      url: uploadImg,
      headers: {
        Authorization: this.$store.state.token || ""
      }
    };
  },
  methods: {
    commodityClassifyLists() {
      commodityClassifyLists().then(res => {
        this.options = res.data;
      });
    },
    //点击到商品参数的路上
    tabClick(val) {
      console.log(this.normal.goods_cat);
      if (val.name === "2") {
        if (!this.normal.goods_cat) {
          this.$message.error("请选择商品分类");
        } else {
          getDynamicParameter(
            this.normal.goods_cat[this.normal.goods_cat.length - 1]
          ).then(res => {
            this.normal.attrs = res.data;
            for (let i = 0; i < this.normal.attrs.length; i++) {
              this.normal.attrs[i].attr_vals = this.normal.attrs[
                i
              ].attr_vals.split(",");
            }
          });
        }
      } else if (val.name === "3") {
        if (!this.normal.goods_cat) {
          this.$message.error("请选择商品分类");
        } else {
          getOnlyParameter(
            this.normal.goods_cat[this.normal.goods_cat.length - 1]
          ).then(res => {
            this.normal.goods_attrs = res.data;
            console.log(res.data);
          });
        }
      }
    },
    //删除商品参数
    removerItem(index, _index) {
      this.normal.attrs[index].attr_vals.splice(_index, 1);
    },
    uploadImg() {
      return uploadImg();
    },
    //上图片成功
    getUrl(val) {
      console.log(val);
      let obj = {
        pic: val.data.tmp_path
      };
      this.normal.pics.push(obj);
    },
    //删除图片
    removeUrl(val) {
      console.log(val);
      let tmp_path = val.response.data.tmp_path;
      let index = this.normal.pics.findIndex(item => {
        return item.pic === tmp_path;
      });
      this.normal.pics.splice(index, 1);
    },
    //发布商品  
    publicGoods(){
           this.normal. goods_cat=  this.normal. goods_cat.join(',')
            publicGoods(this.normal)
           .then(res=>{
              this.$message({
                 type:"success",
                 message:'添加成功'
              })
             this.$router.push({
                name:'goods'
             })
             })
    }
  },
  created() {
    this.commodityClassifyLists();
  }
};
</script>
<style scoped >
.goods {
  padding: 15px;
  background: #fff;
  border-radius: 10px;
}
.breadcrumb-wrap {
  margin-bottom: 20px;
}
.inpt-wrap {
  display: flex;
  justify-content: flex-start;
  margin-bottom: 20px;
}
#qunit-bannerx {
  margin-top: 20px;
}
</style>

